volatile char date[10];
volatile char time[10];


unsigned char getd(unsigned char nn)
{
 return ((nn & 0xF0)>>4)+0x30;
}

unsigned char getu(unsigned char nn)
{
  return (nn  & 0x0F)+0x30;
}

 void main(){
 
  char *text;
  char mem_data;
  unsigned char tmp;
  unsigned i;
  
  PORTB = 0;
  TRISB = 0;

  Lcd8_Config(&PORTE, &PORTD, 2,1,0,7,6, 5, 4, 3, 2, 1, 0); // Lcd_Init_EP5, see Autocomplete
  LCD8_Cmd(LCD_CURSOR_OFF);                 // send command to LCD (cursor off)
  LCD8_Cmd(LCD_CLEAR);                      // send command  to LCD (clear LCD)

  text = "I2C EEPROM DEMO";                       // assign text to string
  LCD8_Out(1,1,text);                       // print string a on LCD, 1st row, 1st column


  Soft_I2C_Config(&PORTC, 4, 3);


  Soft_I2C_Start();        // Issue I2C start signal

  Soft_I2C_Write(0xA2);          // Send byte via I2C  (Address of 24cO2)
  Soft_I2C_Write(2);             // Send byte (address of EEPROM location)
  Soft_I2C_Write('N');          // Send data (data to be written)
  Soft_I2C_Write('i');          // Send data (data to be written)
  Soft_I2C_Write('k');          // Send data (data to be written)
  Soft_I2C_Write('o');          // Send data (data to be written)
  Soft_I2C_Write('s');          // Send data (data to be written)

  Soft_I2C_Stop();

  Delay_ms(100);


  Soft_I2C_Start();               // Issue I2C start signal
  Soft_I2C_Write(0xA2);          // Send byte (device address + W)
  Soft_I2C_Write(2);             // Send byte (address of EEPROM location)


  Soft_I2C_Start();               // Issue I2C start signal
  Soft_I2C_Write(0xA3);          // Send byte (device address + R)
  for (i=0;i<5;i++) {
      mem_data = Soft_I2C_Read(0);    // Read the data (NO acknowledge)
      Lcd8_Chr(2,i+1, mem_data);
  }

  Soft_I2C_Stop();
  
  
  delay_ms(3000);


  // Read time form Real_time clock DS1307

  Soft_I2C_Start();
  Soft_I2C_Write(0xD0);   //Address of Real Time Clock + W
  Soft_I2C_Write(0);      //Addess  of First Register to Read from RTC

  Soft_I2C_Start();       // Send Restart
  Soft_I2C_Write(0xD1);   //  Address of Real Time Clock + R
  tmp= 0x7F & Soft_I2C_Read(1); //Read Seconds from RTC and send ACK
  time[5]=':';
  time[6]=getd(tmp);
  time[7]=getu(tmp);
  time[8]=0;

  tmp= 0x7F & Soft_I2C_Read(1); //Read  minutes from RTC and send ACK
  time[2]=':';
  time[3]=getd(tmp);
  time[4]=getu(tmp);

  tmp= 0x3F & Soft_I2C_Read(1); //Read Hours from RTC and send ACK
  time[0]=getd(tmp);
  time[1]=getu(tmp);


  Soft_I2C_Read(1); //dia semana

  tmp= 0x3F & Soft_I2C_Read(1); //Read Day from RTC and send ACK
  date[0]=getd(tmp);
  date[1]=getu(tmp);


  tmp= 0x1F & Soft_I2C_Read(1); //Read Month from RTC and send ACK
  date[2]='/';
  date[3]=getd(tmp);
  date[4]=getu(tmp);

  tmp=  Soft_I2C_Read(0); //Read Year  from RTC and send NO ACK  to end reading
  date[5]='/';
  date[6]=getd(tmp);
  date[7]=getu(tmp);
  date[8]=0;

  Soft_I2C_Stop();  // Send Stop

  Lcd8_Out(1,1,time);
  Lcd8_out(2,1,date);

  


  while(1);
  

  
}